--- 11/manager.c	2007-07-20 23:54:10.000000000 +0400
+++ 12/manager.c	2007-09-06 14:31:15.000000000 +0400
@@ -567,8 +567,8 @@
 	return RESULT_SUCCESS;
 }
 
-/*! \brief CLI command show manager connected */
-/* Should change to "manager show connected" */
+/*! \brief CLI command show manager eventq */
+/* Should change to "manager show eventq" */
 static int handle_showmaneventq(int fd, int argc, char *argv[])
 {
 	struct eventqent *s;
@@ -683,10 +683,10 @@
 {
 	AST_LIST_LOCK(&sessions);
 	AST_LIST_REMOVE(&sessions, s, list);
+	free_session(s);
 	AST_LIST_UNLOCK(&sessions);
 
 	ast_atomic_fetchadd_int(&num_sessions, -1);
-	free_session(s);
 }
 
 const char *astman_get_header(const struct message *m, char *var)
@@ -2277,8 +2277,6 @@
 		if (!(s = ast_calloc(1, sizeof(*s))))
 			continue;
 
-		ast_atomic_fetchadd_int(&num_sessions, 1);
-		
 		memcpy(&s->sin, &sin, sizeof(sin));
 		s->writetimeout = 100;
 		s->waiting_thread = AST_PTHREADT_NULL;
@@ -2302,7 +2300,11 @@
 		while(s->eventq->next)
 			s->eventq = s->eventq->next;
 		AST_LIST_UNLOCK(&sessions);
+
 		ast_atomic_fetchadd_int(&s->eventq->usecount, 1);
+
+		ast_atomic_fetchadd_int(&num_sessions, 1);
+		
 		if (ast_pthread_create_background(&s->t, &attr, session_do, s))
 			destroy_session(s);
 	}
